package eu.dnetlib.uoaadmintools.entities;

import com.fasterxml.jackson.annotation.JsonProperty;
import eu.dnetlib.uoaadmintools.entities.layoutEntities.Box;
import eu.dnetlib.uoaadmintools.entities.layoutEntities.Buttons;
import eu.dnetlib.uoaadmintools.entities.layoutEntities.Links;
import eu.dnetlib.uoaadmintools.entities.layoutEntities.Panel;
import org.springframework.data.annotation.Id;

public class Layout {

    @Id
    @JsonProperty("_id")
    private String id;
    private String mainColor;
    private String secondaryColor;
    private Panel panel;
    private Box box;
    private Links links;
    private Buttons buttons;

    private String portalPid;

    public Layout() { }

    public Layout(String id, String mainColor, String secondaryColor, Panel panel, Box box, Links links, Buttons buttons, String portalPid) {
        this.id = id;
        this.mainColor = mainColor;
        this.secondaryColor = secondaryColor;
        this.panel = panel;
        this.box = box;
        this.links = links;
        this.buttons = buttons;

        this.portalPid = portalPid;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getMainColor() {
        return mainColor;
    }

    public void setMainColor(String mainColor) {
        this.mainColor = mainColor;
    }

    public String getSecondaryColor() {
        return secondaryColor;
    }

    public void setSecondaryColor(String secondaryColor) {
        this.secondaryColor = secondaryColor;
    }

    public Panel getPanel() {
        return panel;
    }

    public void setPanel(Panel panel) {
        this.panel = panel;
    }

    public Box getBox() {
        return box;
    }

    public void setBox(Box box) {
        this.box = box;
    }

    public Links getLinks() {
        return links;
    }

    public void setLinks(Links links) {
        this.links = links;
    }

    public Buttons getButtons() {
        return buttons;
    }

    public void setButtons(Buttons buttons) {
        this.buttons = buttons;
    }

    public String getPortalPid() {
        return portalPid;
    }

    public void setPortalPid(String portalPid) {
        this.portalPid = portalPid;
    }
}
